'==========================================================================
'
' NAME: Message_Notification
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 8/29/2007
'
' A wrapper around the Shell.Popup method
'
' USAGE:
'	cscript.exe Message_Notification.vbs
'		/message:"message text"
'		[/title:"title bar text"]
'		[/time:{0 | n}] 
'	where n (time) 	is the number of seconds to display the message
'					and zero means display message until button is clicked
'					if omitted, 60 seconds is the Default
'	if /title		omitted, "Notification" is the default title bar
'
' REFERENCE:
' http://msdn2.microsoft.com/en-us/library/x83z1d9f.aspx
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

Const PopupOK = 0
Const PopupWarning = 48

sMessage = WScript.Arguments.Named("message")
sTitle = WScript.Arguments.Named("title")
iWait = WScript.Arguments.Named("time")

if sMessage = "" then WScript.Quit(0)
if sTitle = "" then sTitle = "NOTIFICATION"
if iWait = "" then iWait = 60

Set oShell = CreateObject("WScript.Shell")
Call oShell.Popup (sMessage, iWait, sTitle, PopupWarning + PopupOK)