'==========================================================================
'
' NAME: Share_Create
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 7/29/2007
'
' USAGE:
'	cscript.exe Share_Create.vbs
'		/server:<servername>
'		/path:<path to folder>
'		/sharename:<share name>
'		[/cache:Manual | Documents | Programs | None]
'		[/remark:<caption>]
'		[/username:<user name with rights to create shared folders> /password:<password>]
' NOTES:
' 		If /cache is omitted, NONE will be used
'		/remark can be omitted: share description will be blank
'
' REFERENCE:
'	http://msdn.microsoft.com/library/default.asp?url=/library/en-us/script56/html/
'		 5a6b4437-2339-408e-952f-d49e399e9696.asp
'	http://cwashington.netreach.net/depo/view.asp?Index=1068
'	http://cwashington.netreach.net/depo/view.asp?Index=1115
'
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

Option Explicit

'==========================================================================
' CONFIGURATION BLOCK
Dim PSEXEC
' Configure the full path to psexec.exe 
' No path required if psexec.exe is in the same folder as the script
PSEXEC = "psexec.exe"
' You can also change business logic below,
' where the SMB ACL (share permissions) is configured To
' Everyone::Allow::Full
'==========================================================================

'WshShell Run method options
Const WAIT_ON_RETURN = True
Const HIDE_WINDOW = 0
Const MAX_FOCUS = 3

Dim oWMIService
Dim oSecDescClass, oSecDesc, oTrustee, oACE
Dim oWin32Share, oInParam, oOutParams
Dim WSHShell
Set WSHShell = CreateObject("WScript.shell")
Dim sCommandLine

' Get arguments passed to script
Dim oArgs
Set oArgs = WScript.Arguments.Named
Dim sServer, sPath, sShareName, sCache, sRemark, sUsername, sPassword
sServer = oArgs("server")
sPath = oArgs("path")
sShareName = oArgs("sharename")
sCache = oArgs("cache")
sRemark = oArgs("remark")
sUsername = oArgs("username")
sPassword = oArgs("password")

' Check for valid arguments
If sServer = "" Or sPath = "" Or sShareName = "" Or _
	(oArgs.Exists("username") And (Not oArgs.Exists("password"))) Then
	Call HandleError(501, "Required arguments missing", True)
End If

If sCache = "" Then sCache = "None"

' Connect to WMI on server
Set oWMIService = ConnectWMI(sServer, "root\cimv2", sUsername, sPassword)
If oWMIService Is Nothing Then
	' ERROR HANDLING FOR UNABLE TO CONNECT TO WMI
	If sServer = "." Then sServer = "the local computer"
	Call HandleError(501, "Unable to connect to WMI on " & sServer, True)
End If

' Delete any existing Share
' Using net share:
'	sCommand = "net share """ & sShareName & """ /d"
On Error Resume Next 
Set oOutParams = oWMIService.ExecMethod("Win32_Share.Name='" & sShareName & "'", "Delete")
' Assuming any error results from the fact that the share did NOT already exist
On Error GoTo 0

' Create a security descriptor for the new share
Set oSecDescClass = oWMIService.Get("Win32_SecurityDescriptor")
Set oSecDesc = oSecDescClass.SpawnInstance_()

Set oTrustee = oWMIService.Get("Win32_Trustee").SpawnInstance_
Set oACE = oWMIService.Get("Win32_Ace").SpawnInstance_
' CONFIGURATION (Optional)
' Use these three lines of code for "EVERYONE"
oTrustee.Domain = Null
oTrustee.Name = "EVERYONE"
oTrustee.Properties_.Item("SID") = Array(1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0)
' For a user/group other than Everyone, use the following line 
' instead of the previous three lines
' Set oTrustee = Trustee_Get("<domain>", "<name>", "user | group")

' CONFIGURATION (Optional) 
oACE.Properties_.Item("AccessMask") = 2032127
' 2032127 = "Full"
' 1245631 = "Change"
' 1179817 = "Read"

oACE.Properties_.Item("AceFlags") = 3
oACE.Properties_.Item("AceType") = 0
oACE.Properties_.Item("Trustee") = oTrustee
oSecDesc.Properties_.Item("DACL") = Array(oACE)

' Create the Share
' Using net share:
'	sCommand = "net share """ & sShareName & """=""" & sFolderPath & """" & _
'		" /GRANT:Everyone,Full" & _
Set oWin32Share = oWMIService.Get("Win32_Share")
Set oInParam = oWin32Share.Methods_("Create").InParameters.SpawnInstance_()
oInParam.Properties_.Item("Access") = oSecDesc
oInParam.Properties_.Item("Description") = sRemark
oInParam.Properties_.Item("Name") = sShareName
oInParam.Properties_.Item("Path") = sPath
oInParam.Properties_.Item("Type") = 0
Set oOutParams = oWin32Share.ExecMethod_("Create", oInParam)

' Configure caching settings
' We're having to use NET SHARE for now,
' because there is no other way we've found 
' to configure the CACHING settings
sCommandLine = "net share """ & sShareName & """ /CACHE:" & sCache
PSExec_Run sCommandLine, sServer

WScript.Quit (0)

' FUNCTIONS FROM LIBRARY

Function ConnectWMI(ByVal sComputer, ByVal sWMINamespace, ByVal sUsername, ByVal sPassword)
	' Version 070805
	' Connects to a WMI namespace on a specified computer using specific credentials
	' INPUTS:	sComputer:		the computer to which to connect ("." for local)
	'			sWMINamespace:	the namespace to which to connect (e.g. "root\cimv2")
	'			sUsername:		alternate credentials username ("" to use existing credentials)
	'			sPassword:		alternate credentials password ("" to use existing credentials)
	' OUTPUTS:	ConnectWMI:		an object reference to sComputer's sWMINamespace namespace
	
    Dim oLocator
    Dim oWMI
    
    ' WMI Does not support credentials for connection to a local computer
    
    If sComputer = "." Then
    	sUsername = ""
    	sPassword = ""
    End If
    	
    Set oLocator = WScript.CreateObject("WbemScripting.SWbemLocator")
    On Error Resume Next
    set oWMI = oLocator.ConnectServer(sComputer, sWMINamespace, sUsername, sPassword)

    If Err.Number <> 0 Then
		' check if user passed credentials for the local machine
        ' (wmi doesn't support connecting to the local machine with alternate credentials)
        '
        If Err.Number = -2147217308 Then
            ' wmiLocalCredentialsSupplied 

            ' supress the credentials
            sComputer = "."
            sUsername = ""
            sPassword = ""

            ' try connecting again
            Err.Clear
            Set oWMI = oLocator.ConnectServer( ".", sWMINamespace, "" , "" )
            If Err <> 0 Then
            	' ERROR HANDLING STILL CAN'T CONNECT TO LOCAL WMI
            	Err.Clear
            End If
		Else
			' ERROR HANDLING FOR OTHER ERRORS
			Err.Clear
            End If
	End If
	
    ' set the security level
    oWMI.Security_.impersonationlevel = 3
    
    ' return the object to the caller
    Set ConnectWMI = oWMI
End Function

Function Trustee_Get(ByVal sDomain, ByVal sName, ByVal sType)
	Dim oTrustee
	Dim account
	Dim accountSID
	
	Set oTrustee = getObject("Winmgmts:{impersonationlevel=impersonate}!root/cimv2:Win32_Trustee").Spawninstance_ 
	If UCase(sType) = "GROUP" Then
		set account = getObject("Winmgmts:{impersonationlevel=impersonate}!root/cimv2:Win32_Group.Name='" & sName & "',Domain='" & sDomain &"'")
	Else
		set account = getObject("Winmgmts:{impersonationlevel=impersonate}!root/cimv2:Win32_Account.Name='" & sName & "',Domain='" & sDomain &"'") 
	End If
	
	Set accountSID = getObject("Winmgmts:{impersonationlevel=impersonate}!root/cimv2:Win32_SID.SID='" & account.SID &"'") 
	
	If sDomain = "" Then
		oTrustee.Domain = Null
	Else
		oTrustee.Domain = sDomain
	End If
	
	oTrustee.Name = sName 
	oTrustee.Properties_.item("SID") = accountSID.BinaryRepresentation 
	
	Set accountSID = nothing 
	Set account = nothing 
	Set Trustee_Group_Get = oTrustee 

End Function 

Function PSExec_Run(sCommand,sMachine)
	Dim sCommandLine
	If sMachine = "." Then
		sCommandLine = "cmd.exe /c " & PSExec & " " & sCommand
	Else
		sCommandLine = "cmd.exe /c " & PSExec & " \\" & sMachine & " " & sCommand
	End If
	WSHShell.Run sCommandLine,HIDE_WINDOW,True
End Function

Sub HandleError(errNumber, errDescription, exitFlag)
	WScript.Echo "ERROR: " & WScript.ScriptFullName
	WScript.Echo "       " & errNumber & ": " & errDescription
	If exitFlag Then
		WScript.Quit(errNumber)
	Else
		Err.Clear
		On Error GoTo 0		
	End If		
End Sub