'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: Computer_InfoToDescription.vbs
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 12/16/2007
'
' USAGE:  
' cscript.exe User_Fix_UPNs.vbs <DN of OU with users>
'
' This script sets the userPrincipalName attribute of users 
' to the user's email address
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================
Dim sOUDN

Call Arguments()

WScript.echo WScript.ScriptName
WScript.echo String(Len(WScript.ScriptName), "=")
WScript.echo
WScript.echo "Changing userPrincipalName attribute of users in " & vbCrLf & sOUDN
WScript.echo
Set oTargetOU = GetObject("LDAP://" & sOUDN)
oTargetOU.Filter = Array("user")

For Each oUser In oTargetOU
				
	If InStr(oUser.sAMAccountName, "$") = 0 Then
		' Filter out comptuer objects which have sAMAccountNames ending with $
				
		On Error Resume Next
		' Possible that a user doesn't have one of these properties
		sEmail = oUser.get("mail")
		If Err.Number <> vbEmpty Then Err.Clear
		On Error Goto 0
		
		If sEmail > "" Then
			oUser.put "userPrincipalName", sEmail
			oUser.setinfo
			WScript.echo oUser.userPrincipalName
		Else
			WScript.Echo "** ERROR ** did not change: " & oUser.cn
		End If
				
	End If

Next

Sub Arguments()
	Dim oArgs
	Set oArgs = WScript.Arguments
	If oArgs.Count <> 1 Then 
		Call Usage()
	Else
		sOUDN = oArgs(0)
	End If
End Sub

Sub Usage()
	WScript.Echo
	WScript.Echo "Usage:   cscript.exe " & WScript.ScriptName & vbCrLF & "    <DN of OU in which to change user principal names>" 
	WScript.Echo 
	WScript.Echo "Example: cscript.exe " & WScript.ScriptName & vbCrLf & "    ""ou=Employees,dc=contoso,dc=com"""
	WScript.Quit(0)
End Sub