'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: Group_Subscribe.vbs
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 12/12/2007
'
' USAGE:  
' cscript.exe Group_Subscribe.vbs
'
' Adds the current user to the group specified in the
' configuration block.
' The group must have a permission on its ACL such as
' Authenticated Users::Allow::Add/Remove Self As Member
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
'==========================================================================

'==========================================================================
' CONFIGURATION BLOCK - You only need to change sGROUPDN
sGroupDN = "cn=GPO_Classic Windows,ou=CCM,ou=Groups,dc=contoso,dc=com"
'==========================================================================

sUserDN = CreateObject("ADSystemInfo").UserName
If Group_AddMember("LDAP://" & sGroupDN, "LDAP://" & sUserDN) Then
	MsgBox "You have been successfully added to the group."
Else
	MsgBox "There was a problem adding you to the group."
End If

Function Group_AddMember(ByVal sGroupADsPath, ByVal sMemberADsPath)
	' Version 071130
	Dim oGroup, oMember
	On Error Resume Next
	Set oGroup = GetObject(sGroupADsPath)
	If Err.Number <> 0 Then
		' Handle error: could not connect to group
		Group_AddMember = False
		Err.Clear
		Exit Function
	End If
	oGroup.Add sMemberADsPath
	If Err.Number > 0 then
		' Handle error: could not add member
		Group_AddMember = False
		Err.Clear
	Else
		Group_AddMember = True
	End If
	On Error Goto 0
End Function
