'==========================================================================
'
' VBScript Source File -- Created with SAPIEN Technologies PrimalScript 2007
'
' NAME: Software_Setup.vbs
'
' AUTHOR: Dan Holme , Intelliem
' DATE  : 11/23/2007
'
' USAGE:  
' cscript.exe Software_Setup.vbs
'
' COMMENT: Used to deploy an application
' The script requires Software_Setup_Core.vbs
' in the path specified in the Configuration Block
'
' See the Windows Administration Resource Kit for documentation
'
' Neither Microsoft nor Intelliem guarantee the performance
' of scripts, scripting examples or tools.
'
' See www.intelliem.com/resourcekit for updates to this script
'
' (c) 2007 Intelliem, Inc
' You are free to use this script and make derivatives of it,
' but you may not remove any of this header.
' We also ask that any functional improvements be reported to
' Intelliem at the URL above for the benefit of all.
'==========================================================================

Option Explicit
Dim sWorkingDir, sCommand, sCommandType, sCommandArgs, sSuccessCodes, sCoreFileName
' ===================================================================================
' CONFIGURATION BLOCK
' This is the main code you would need to change for a specific application
'
' THE SAMPLES ILLUSTRATE SILENT INSTALLATION OF MICROSOFT'S XML NOTEPAD
'
' sWorkingDir is the folder where application installation files are found.
' You can use the variable %CD% to represent the folder that this script is in.
sWorkingDir = "%CD%"
' sCommand is the main executeable to be launched
' You can use the variable %WD% to represent the folder the application is in
' represented by sWorkingDir
sCommand = "%WD%\XMLNotepad.msi"
' sCommandArgs is the string of arguments passed to the setup command (sCommand)
sCommandArgs = ""
' sCommandType is EXE or MSI
sCommandType = "MSI"
' sSuccessCodes is a comma-delimited list of codes returned by the setup command If
' setup is successful. 0 and 3010 are typical, but you will need to test the setup
' of the application to determine what other codes are returned.
' To test the application, run the setup command from the command prompt
' then type ECHO %ERRORLEVEL%.
' When installation is performed, it is considered successful if a return code matches
' a value in sSuccessCodes
sSuccessCodes = "0,3010"
'
' Configure the path to the Software_Setup_Core.vbs script
sCoreFileName = "\\contoso.com\software\contoso\software management\Software_Setup_Core.vbs"
' ===================================================================================

' Set FSO globally to improve performance of File_FindClosest()
Dim FSO
Set FSO = CreateObject("Scripting.FileSystemObject")

' Include the core script (sCoreFileName)
Call IncludeInstallerCore()
Call Initialize()

' ===================================================================================
' Here is the beginning of your installation routine.
' Generally, you will start with just Call Install() which executes the
' setup command configured in the Configuration Block
' To create an "INSTALL CURRENT VERSION" script, redefine sWorkingDir here
' using the Find_Folder() function in the core script, e.g.
' sWorkingDir = Find_Folder()
Call Install()

' ===================================================================================
' Here, you might add additional code to perform post-installation configuration
' of the application (e.g. changing registry entries, etc.
' ===================================================================================

Sub IncludeInstallerCore()
	' Locate and include the core script specified by sCoreFileName
	Dim FSO, oFile, sText
	Set FSO = CreateObject("Scripting.FileSystemObject")

	If FSO.FileExists(sCoreFileName) Then
		Set oFile = fso.OpenTextFile(sCoreFileName)
		sText = oFile.ReadAll()
		oFile.Close
		ExecuteGlobal sText
	Else
		WScript.Echo "Cannot locate core installation script " & sCoreFileName
	End If
End Sub
